-- based on mandelbrot from here: http://gregheartsfield.com/fractal-hs/
module Main where
import Graphics.GD
import Data.Complex
import Plot
--import System.Random

-- Coordinates in the complex plane to graph
-- First coordinate must be top left.
fishbt :: Window
fishbt = ( (-1.5, 1.1), (1.2, -1.1) ) 



main :: IO ()
main = plot drawmandelbrot (1000,1000) -- change for smaller/larger png files
       fishbt "fish.png" -- name

drawmandelbrot :: Pos -> Color -- :+ from Data.Complex creates a complex number (Re :+ Im)
drawmandelbrot (x,y) = colorin $ mandelbrot (x :+ y) (0  :+ 0) (0 :+ 0) 1

--drawagain :: Color -> Color


-- Count number of iterations for the given point to diverge
-- Non-diverging points return 0
mandelbrot :: Complex Double -> Complex Double -> Complex Double -> Int -> Int
mandelbrot c z d iter
    | iter > 30 = 0 -- max iterations
    | otherwise = let z' = z^2 + d^3 + c
                      d' = 2*z^2 + c in
                      if (magnitude z' > 10)
                      then  iter
                      else if (magnitude d' > 8)
                           then  mandelbrot c d' z' (iter+2)
                      else mandelbrot c d' z' (iter+1)
                                                                                            
colorin :: Int -> Color
colorin x 
    | x > 10 = rgb 270 200 230
    | otherwise = rgb (a x) (b x) (c x)
                  where a x = x ^ 3
                        b x = (x ^ 2) * 3
                        c x = x
    
--timeToInt time = do
  --  tm <- ((read <$> formatTime defaultTimeLocale "%S" <$> getCurrentTime) :: IO Int)
    

